/*
 * Copyright 2010-2011, Softnik Technologies
 * http://www.softnik.com/
 */

///////////////////////////////////////////////////////////////////////////////
var grid_url_base           = "lib/php/datagrid.php";
///////////////////////////////////////////////////////////////////////////////

$(function()
{
	// Vertical splitter. Set min/max/starting sizes for the left pane.
	// cookies will not work on Chrome running in localhost
	// cookiePath: '/' is required for IE.
	
	$("#SplitterPane").splitter({
		splitVertical: true,
		outline: true,
		sizeLeft: true,
		anchorToWindow: true,
		cookie: "vsplitter",
		cookiePath: '/',
		accessKey: "I"
	});
	
	// Horizontal splitter, nested in the right pane of the vertical splitter.
	$("#RightPane").splitter({
		splitHorizontal: true,
		sizeTop: true,
		cookie: "hsplitter",
		cookiePath: '/',
		outline: true,
		accessKey: "H"
	});	

});

