<?php
/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2010-2011 Softnik Technologies
// Version 0.1.11 2011-01-15
// Initial Version: Anil Kumar
//
// Modified: Feb 15, 2013: SK
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////

function install_wmdsed($dbtablepath)
{
	$success = true;
	$status = array();
	
	global $db_config_host, $db_config_username, $db_config_password, $db_config_database, $valid_domain_table_array, $db_table_prefix;
	
	$dbLink = @mysql_connect($db_config_host, $db_config_username, $db_config_password);
	if(!$dbLink) 
	{
		$success = false;
		$status[] = 'Could not connect: ' . mysql_error();
	}
	else
	{
		mysql_query("SET NAMES 'utf8'");
		$db_selected = mysql_select_db($db_config_database);
		if (!$db_selected) 
		{
			$status[] = "Error: " . mysql_error();
			$success = false;
		}
	}

	if($success == true)
	{
		$dbtable_array = array();
		
		$i = 0; $found = 0;
		$sql = "SHOW TABLES FROM $db_config_database";
		$result = mysql_query($sql);
		if($result) 
		{
			while ($row = mysql_fetch_row($result)) 
			{
				$dbtable_array[$i++] = $row[0];
				if(in_array($row[0], $valid_domain_table_array))
					$found++;
			}
		}
		else
		{
		}
		
		if($found)
		{
			
		
			if($found == count($valid_domain_table_array))
			{
				$added = add_missing_fields($status);
				if(!$added)
					$status[] = "Database is already setup!";
				$status[] = "You should be able to <a href=" . get_base_path() . ">run the application</a> now.";
				$status[] = "If you wish to use a different set of database tables, please specify another \"db_table_prefix\" in \"config.php\" and run this script again.";
				$success = false;
			}
			else if($found > 0)
			{
				$trycount = 0;
				$successcount = 0;
				foreach($valid_domain_table_array as $key=>$val)
				{
					if(in_array($val, $dbtable_array))
						continue;
					else
					{
						$trycount++;
						if(make_db_tables($dbtablepath, $db_table_prefix, $status, $val) == true)
							$successcount++;
					}
				}
				if($trycount && $trycount == $successcount)
				{
					add_missing_fields($status);
					
					$status[] = "The database contained a partial prior installation. It was repaired.";
					$status[] = "You should be able to <a href=" . get_base_path() . ">run the application</a> now.";
					$status[] = "If you wish to use a different set of database tables, please specify another \"db_table_prefix\" in \"config.php\" and run this script again.";
					$success = false;
				}
				else
				{
					add_missing_fields($status);
					
					$status[] = "The database already contains some of the tables. This means your installation is only partially complete and there is a problem!";
					$status[] = "Please modify / clean the database or specify another \"db_table_prefix\" in 'config.php' before running this installation script.";
					$status[] = "<hr>";
					$status[] = "Please <a href=\"http://www.softnik.com/icenter/contact.php\">contact us</a> if you still have problems.";
					$success = false;
				}
			}
			
		}
		else
			make_db_tables($dbtablepath, $db_table_prefix, $status);
	}
		
	if($success == true)
	{
		$status[] = "Tables successfully created.";
		$status[] = "You should be able to <a href=" . get_base_path() . ">run the application</a> now.";
		show_success_page($status);
	}
	else
		show_error_page($status);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function make_db_tables($path, $prefix, &$status, $onetable="")
{
	$success = true;
	$handle = @fopen($path, "r"); 
	
	$process = true;
	$lookfor = "";
	if($onetable != "")
	{
		$onetable = str_replace($prefix, "", $onetable);
		if($onetable != "")
		{
			$lookfor = "DROP TABLE IF EXISTS `[[DB_PREFIX]]" . $onetable . '`';
			$process = false;
		}
	}
	
	if ($handle) 
	{ 
		$query = '';
		while (!feof($handle)) 
		{     
			$found = false;
			$text = fgets($handle, 4096);
			$text = trim($text);
			if($lookfor != "")
			{
				//echo "<pre> $text </pre>";
				if($process == false)
				{
					if(substr($text, 0, strlen($lookfor)) == $lookfor)
					{
						$process = true;
						$found = true;
					}
				}
				if($process == true && $found == false)
				{
					$nextdrop = "DROP TABLE IF EXISTS `[[DB_PREFIX]]";
					if(substr($text, 0, strlen($nextdrop)) == $nextdrop)
						$process = false;
				}
			}
			
			if($process == false)
				continue;
				
			$query .= $text;
			$last = mb_substr($text, -1, 1);
			if($last == ';')
			{      
				$query = str_replace("[[DB_PREFIX]]", $prefix, $query);
				//echo "<pre>$query \r\n</pre>";
				$result = mysql_query($query);
				if (!$result) 
				{
					$status[] = "Error: " . mysql_error();
					$success = false;
				}
				$query = '';     
			}
		} 
		fclose($handle); 
	} 
	else
	{
		$success = false;
		$status[] = "Unable to open lib/php/data/tables.sql";
	}
	return $success;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function add_missing_fields(&$status)
{
	global $db_config_domain_table, $db_config_database, $db_config_whoisservers_table;
	$added = 0;
	
	$fields = mysql_list_fields($db_config_database, $db_config_domain_table);
	$columns = mysql_num_fields($fields);
	for ($i = 0; $i < $columns; $i++) 
	{
		$field_array[] = mysql_field_name($fields, $i);
	}
	
	$domain_table_fields = array(
		"ip_whois", 	"LONGTEXT NULL",
		"ip_whois_at", 	"datetime NULL",
		"added_on", 	"datetime NULL",
		"ip_org_name",  "varchar(255) NULL",
		"ip_net_name",  "varchar(255) NULL",
		"ip_rtech_name",  "varchar(255) NULL",
		"ip_asname",  "varchar(255) NULL",
		"ip_asnumber",  "varchar(16) NULL",
		"notes_a", "varchar(255) NULL",
		"notes_b", "varchar(255) NULL",
		"notes_c", "varchar(255) NULL",
		"notes_d", "varchar(255) NULL"
	);
	$count = count($domain_table_fields)/2;
	for($i = 0; $i < $count; $i++)
	{
		if (!in_array($domain_table_fields[$i*2], $field_array))
		{
			$result = mysql_query('ALTER TABLE ' . $db_config_domain_table . " ADD " . $domain_table_fields[$i*2] . " " . $domain_table_fields[$i*2+1]); 
			if($result)
			{
				$status[] = 'Added column ' . $domain_table_fields[$i*2];
				$added++;
			}
			else
				die("Couldn't execute your query.".mysql_error());
		}
	}

	unset($field_array);
	$fields = mysql_list_fields($db_config_database, $db_config_whoisservers_table);
	$columns = mysql_num_fields($fields);
	for ($i = 0; $i < $columns; $i++) 
	{
		$field_array[] = mysql_field_name($fields, $i);
	}
	$server_table_fields = array(
		"last_connect_at", "datetime NULL"
	);
	$count = count($server_table_fields)/2;
	for($i = 0; $i < $count; $i++)
	{
		if (!in_array($server_table_fields[$i*2], $field_array))
		{
			$result = mysql_query('ALTER TABLE ' . $db_config_whoisservers_table . " ADD " . $server_table_fields[$i*2] . " " . $server_table_fields[$i*2+1]); 
			if($result)
			{
				$status[] = 'Added column ' . $server_table_fields[$i*2];
				$added++;
			}
			else
				die("Couldn't execute your query.".mysql_error());
		}
	}
	
	return $added;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

?>
